﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using Syncfusion.SfChart.XForms;

using Xamarin.Forms;

namespace MinorTickLine
{
	public partial class MajorTick : ContentPage
	{
		public MajorTick()
		{
			InitializeComponent();

			SfChart chart = new SfChart();

			DateTimeAxis primaryAxis = new DateTimeAxis();
			primaryAxis.Minimum = new DateTime(2015, 1, 1);
			primaryAxis.Maximum = new DateTime(2020, 12, 30);

			chart.PrimaryAxis = primaryAxis;

			NumericalAxis secondaryAxis = new NumericalAxis();
			chart.SecondaryAxis = secondaryAxis;

			ViewModel model = new ViewModel();

			LineSeries lineSeries = new LineSeries();
			lineSeries.ItemsSource = model.DataPoints;

			var dataTemplate = new DataTemplate(() =>
			   {
					var grid = new Grid();

				    var label1 = new Label();
				    var label2 = new Label();
				   
				   	label1.SetBinding(Label.TextProperty, "XValue",stringFormat:"{0:MMMM dd}");
					label2.SetBinding(Label.TextProperty, "YValue",stringFormat:"{0:C}");
				   
				    grid.Children.Add(label1);
				    grid.Children.Add(label2, 0, 1);
				    grid.BackgroundColor = Color.Green;
				  
				    return grid;
			    });

			lineSeries.TrackballLabelTemplate = dataTemplate;
			chart.Series.Add(lineSeries);

			ChartTrackballBehavior trackballBehavior = new ChartTrackballBehavior();
			trackballBehavior.ShowLabel = true;
			trackballBehavior.ShowLine = true;
			chart.ChartBehaviors.Add(trackballBehavior);

			this.Content = chart;
		}
	}

	public class ViewModel
	{
		public ObservableCollection<ChartDataPoint> DataPoints { get; set; }

		public ViewModel()
		{
			DataPoints = new ObservableCollection<ChartDataPoint>();
			DataPoints.Add(new ChartDataPoint(new DateTime(2016, 06, 20), 1));
			DataPoints.Add(new ChartDataPoint(new DateTime(2017, 02, 16), 3));
			DataPoints.Add(new ChartDataPoint(new DateTime(2018, 03, 4), 4));
			DataPoints.Add(new ChartDataPoint(new DateTime(2019, 01, 8), 3));
			DataPoints.Add(new ChartDataPoint(new DateTime(2020, 12, 21), 1));

		}
	}

}
